package com.ca.testapp;

import java.io.UnsupportedEncodingException;
import java.text.DecimalFormat;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.Arrays;
import java.lang.System;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.Typeface;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.hardware.usb.UsbConstants;
import android.hardware.usb.UsbDevice;
import android.hardware.usb.UsbDeviceConnection;
import android.hardware.usb.UsbEndpoint;
import android.hardware.usb.UsbInterface;
import android.hardware.usb.UsbManager;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.view.Window;
import android.widget.AdapterView.AdapterContextMenuInfo;

public class MainActivity extends Activity {
	// USB関連のメンバー
	protected static final String ACTION_USB_PERMISSION = "com.ca.testapp.USB";
	private static final String VID_PID = MASYS.UsbVidPid;
	public static UsbDevice sDevice = null;
	private static MainActivity sActivityContext;
	boolean mIsUsbFirst = true;
	final int dataStrlenPerChannel = 5;
	final int INVALID_SEND_DATA = -1;
	AtomicInteger mSenddataExist = new AtomicInteger();

	// プログラムの終了
	private boolean mStop = false;
	private boolean mStopped = true;
	private boolean isFirstEnumerate = true;

	// 取得データ
	final int DataChannelMax = 7;
	int[] mRegisterValue = new int[MASYS.VOLUME_MAX];
	int mChangeRegisterValue;

	// データ処理に使用するメンバー
	long mRawDataCount = 0;// 取得データ数
	int mdbgRawErrorDataCount = 0;// 通信エラーカウント
	int[] mNowData = new int[DataChannelMax];// 現在のAD値
	boolean mIsFirst = true;

	// 画面表示に使用するメンバー
	private MySurfaceView mSurfaceView;
	private Context mContext;
	int mWidth = 0;// 画面の横幅
	int mHeight;// 画面の縦幅
	boolean mIsDrawEffective;//メニュー表示をしている間は、描画をやめる
	int mTouchX, mTouchY;
	AtomicBoolean mIsTouched = new AtomicBoolean();



	// RS232 Line constants
	private static final int CONTROL_DTR = 0x01;
	private static final int CONTROL_RTS = 0x02;
	private static final int UART_DCD = 0x01;
	private static final int UART_DSR = 0x02;
	private static final int UART_RING = 0x08;
	private static final int UART_CTS = 0x80;
	private int ControlLines = 0;

	

	// 設定メニュー
	private int mVoltMenuSelect = 3;
	private int mSecMenuSelect = 4;

	private static final int MENU_ID_SETTING = 0;
	private static final int MENU_ID_CLEARTEXT = 1;
	private static final int REQUEST_PREFERENCE = 0;


	//描画処理本体。画面タッチの処理もここで行う。
	class MySurfaceView extends SurfaceView implements SurfaceHolder.Callback, Runnable {
		// Bitmap backGround ;
		Thread mThread;

		public MySurfaceView(Context context) {
			super(context);
			mContext = context;
			getHolder().addCallback(this);

			// Threadを起動する
			dbg("--surface thread start");
			mThread = new Thread(this);
			mThread.setDaemon(true);
			mThread.start();
		}
		@Override
		public boolean onTouchEvent(MotionEvent event) {
			mTouchX = (int) event.getX();
			mTouchY = (int) event.getY();
		    switch (event.getAction()) {
		    case MotionEvent.ACTION_DOWN:
		        //dbg("TouchEvent getAction()" + "ACTION_DOWN");
				mIsTouched.set(true);
				//dbg("onTouch x=" + mTouchX + " y=" + mTouchY);
				if( mTouchY < mHeight ){
					return true;
				}
		        break;
		    case MotionEvent.ACTION_UP:
		        //dbg("TouchEvent getAction()" + "ACTION_UP");
		        break;
		    case MotionEvent.ACTION_MOVE:
		        //dbg("TouchEvent getAction()" + "ACTION_MOVE");
		        break;
		    case MotionEvent.ACTION_CANCEL:
		        //dbg("TouchEvent getAction()" + "ACTION_CANCEL");
		        break;
		    }
			return false;
		}

		//描画処理スレッド
		@Override
		public void run() {
			long counter = 0 ;
			while( !mStop ){
				if( mWidth != 0 ){//surfaceChanged が呼ばれるまで待つ
					break;
				}
				SleepMs(200);
			}
			if( mStop ) {
				return ;
			}
			Bitmap myImage ;
			Resources resource = mContext.getResources() ;
			myImage = BitmapFactory.decodeResource(resource, R.drawable.a0);

			while( !mStop ){
				if( mStop ){
					break;
				}
				if( mIsDrawEffective == false ){
					// dbg("draw cancel!!!!!!!!!!!");
					SleepMs(100);
					continue;
				}
				Canvas canvas = getHolder().lockCanvas();
				if( canvas != null ){
					doDraw(canvas,myImage);
					getHolder().unlockCanvasAndPost(canvas);
				}
				SleepMs(100);
				int a = (int)counter % 100 ;
                counter ++ ;

				switch( a) {//カウンタの値でモーター制御を切り替えている
				case 10 :
					mChangeRegisterValue = 100 ;//motor percent
					mSenddataExist.set(0);//motor channel
                    Log.d(MASYS.DEBUG_TAG, "a="+a);
					break ;
				case 20 :
					mChangeRegisterValue = 100 ;//motor percent
					mSenddataExist.set(1);//motor channel
                    Log.d(MASYS.DEBUG_TAG, "a="+a);
					break ;
				case 30 :
					mChangeRegisterValue = -100 ;//motor percent
					mSenddataExist.set(0);//motor channel
                    Log.d(MASYS.DEBUG_TAG, "a="+a);
					break ;
				case 40 :
					mChangeRegisterValue = -100 ;//motor percent
					mSenddataExist.set(1);//motor channel
                    Log.d(MASYS.DEBUG_TAG, "a="+a);
					break ;
				case 50 :
					mChangeRegisterValue = 50 ;//motor percent
					mSenddataExist.set(0);//motor channel
                    Log.d(MASYS.DEBUG_TAG, "a="+a);
					break ;
				case 60 :
					mChangeRegisterValue = -50 ;//motor percent
					mSenddataExist.set(1);//motor channel
                    Log.d(MASYS.DEBUG_TAG, "a="+a);
					break ;
				case 70 :
					mChangeRegisterValue = -50 ;//motor percent
					mSenddataExist.set(0);//motor channel
                    Log.d(MASYS.DEBUG_TAG, "a="+a);
					break ;
				case 80 :
					mChangeRegisterValue = 50 ;//motor percent
					mSenddataExist.set(0);//motor channel
                    Log.d(MASYS.DEBUG_TAG, "a="+a);
					break ;
				}
			}
		}

		//描画処理とタッチ判定
		void doDraw( Canvas canvas, Bitmap img) {
			Paint paint = new Paint(Paint.ANTI_ALIAS_FLAG);
			paint.setTextSize(70);
			paint.setColor(Color.BLACK);

			canvas.drawColor(Color.WHITE);// 画面クリア
			double microSvHour =  mNowData[0] * 0.360 / 6.0/*sec*/ ;
			String microSvHourStr = String.format("%2.2f", microSvHour) + "uSv/h";
			canvas.drawText(microSvHourStr, 100, 100, paint) ;
		}


		@Override
		public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {
			mWidth = width;
			mHeight = height;

			int max = mWidth;
			if( max < mHeight ){
				max = mHeight;
			}

			dbg("surfaceChanged");
		}

		@Override
		public void surfaceCreated(SurfaceHolder holder) {
		}

		@Override
		public void surfaceDestroyed(SurfaceHolder holder) {
			Log.d(MASYS.DEBUG_TAG, "surfaceDestroyed");
		}

	}

	// Linux Kernel: drivers/usb/serial/pl2303.c
	private static final int SET_LINE_REQUEST_TYPE = 0x21;
	private static final int SET_LINE_REQUEST = 0x20;
	private static final int BREAK_REQUEST_TYPE = 0x21;
	private static final int BREAK_REQUEST = 0x23;	
	private static final int BREAK_OFF = 0x0000;
	private static final int GET_LINE_REQUEST_TYPE = 0xa1;
	private static final int GET_LINE_REQUEST = 0x21;
	private static final int VENDOR_WRITE_REQUEST_TYPE = 0x40;
	private static final int VENDOR_WRITE_REQUEST = 0x01;
	private static final int VENDOR_READ_REQUEST_TYPE = 0xc0;
	private static final int VENDOR_READ_REQUEST = 0x01;
	private static final int SET_CONTROL_REQUEST_TYPE = 0x21;
	private static final int SET_CONTROL_REQUEST = 0x22;
	

	//USB関連の処理
	private final BroadcastReceiver mPermissionReceiver = new BroadcastReceiver() {
		@Override
		public void onReceive(Context context, Intent intent) {
			if( intent.getAction().equals(ACTION_USB_PERMISSION) ){
				if( !intent.getBooleanExtra(UsbManager.EXTRA_PERMISSION_GRANTED, false) ){
					e("--Permission not granted :(");
				}else{
					dbg("--Permission granted");
					UsbDevice dev = (UsbDevice) intent.getParcelableExtra(UsbManager.EXTRA_DEVICE);
					if( dev != null ){
						if( String.format("%04X:%04X", dev.getVendorId(), dev.getProductId()).equals(VID_PID) ){
							mainloop(dev);// has new thread
						}
					}else{
						e("--device not present!");
					}
				}
			}else if( intent.getAction().equals(Intent.ACTION_UMS_CONNECTED) ){
				intent.setClass(context, MainActivity.class);
				intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
				dbg("Intent.ACTION_UMS_CONNECTED");
				context.startActivity(intent);
			}else if( intent.getAction().equals(Intent.ACTION_UMS_DISCONNECTED) ){
				intent.setClass(context, MainActivity.class);
				intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
				dbg("Intent.ACTION_UMS_DISCONNECTED");
				context.startActivity(intent);
			}else if( intent.getAction().equals(Intent.ACTION_MAIN) ){
				// 通常起動時の処理
				intent.setClass(context, MainActivity.class);
				intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
				dbg("Intent.ACTION_MAIN");
				context.startActivity(intent);
			}
		}
	};

	//USB関連の処理
	private void enumerate() {
		dbg("enumerating");
		UsbManager usbman = (UsbManager) getSystemService(USB_SERVICE);

		HashMap<String, UsbDevice> devlist = usbman.getDeviceList();
		Iterator<UsbDevice> deviter = devlist.values().iterator();
		PendingIntent pi = PendingIntent.getBroadcast(this, 0, new Intent(ACTION_USB_PERMISSION), 0);

		while( deviter.hasNext() ){
			UsbDevice d = deviter.next();
			dbg("--Found device: " + String.format("%04X:%04X", d.getVendorId(), d.getProductId()) + " equal " + MASYS.UsbVidPid + "?");
			if( String.format("%04X:%04X", d.getVendorId(), d.getProductId()).equals(MASYS.UsbVidPid) ){
				// we need to upload the hex file, first request permission
				dbg("--Device under: " + d.getDeviceName());
				registerReceiver(mPermissionReceiver, new IntentFilter(ACTION_USB_PERMISSION));
				if( !usbman.hasPermission(d) ) {
					usbman.requestPermission(d, pi);
					dbg("permission");
				}
				else{
					dbg("--enumrate");
					mainloop(d);
				}
				break;
			}
		}
		dbg("--no more devices found");
	}

	//USB関連の処理
	private void mainloop(UsbDevice d) {
		sDevice = d;// not really nice...
		// if (mIsUsbFirst) {
		mIsUsbFirst = false;
		new Thread(mLoop).start();
	}

	//USBの設定と、データ取得ループスレッド
	private Runnable mLoop = new Runnable() {
		/*
		 * (non-Javadoc)
		 * 
		 * @see java.lang.Runnable#run()
		 */
		@Override
		public void run() {
			dbg("-- mLoop run ----------");
			UsbDevice dev = sDevice;
			if( dev == null ) {
				dbg("dev=null");
				return ;
			}
			UsbManager usbm = (UsbManager) getSystemService(USB_SERVICE);
			if( usbm == null ){
				dbg("usbm=null");
				return;
			}
			UsbDeviceConnection conn = usbm.openDevice(dev);
			dbg("Interface Count: " + dev.getInterfaceCount());
			dbg("Using " + String.format("%04X:%04X", sDevice.getVendorId(), sDevice.getProductId()));

			if( !conn.claimInterface(dev.getInterface(0), true) ) {
				dbg("getInterface error!!");
				return ;
			}
			dbg("start setting");

            byte[] buffer = new byte[1];
            conn.controlTransfer(VENDOR_READ_REQUEST_TYPE, VENDOR_READ_REQUEST, 0x8484, 0, buffer, 1, 100);
            conn.controlTransfer(VENDOR_WRITE_REQUEST_TYPE, VENDOR_WRITE_REQUEST, 0x0404, 0, null, 0, 100);
            conn.controlTransfer(VENDOR_READ_REQUEST_TYPE, VENDOR_READ_REQUEST, 0x8484, 0, buffer, 1, 100);
            conn.controlTransfer(VENDOR_READ_REQUEST_TYPE, VENDOR_READ_REQUEST, 0x8383, 0, buffer, 1, 100);

            conn.controlTransfer(VENDOR_READ_REQUEST_TYPE, VENDOR_READ_REQUEST, 0x8484, 0, buffer, 1, 100);
            conn.controlTransfer(VENDOR_WRITE_REQUEST_TYPE, VENDOR_WRITE_REQUEST, 0x0404, 1, null, 0, 100);
            conn.controlTransfer(VENDOR_READ_REQUEST_TYPE, VENDOR_READ_REQUEST, 0x8484, 0, buffer, 1, 100);
            conn.controlTransfer(VENDOR_READ_REQUEST_TYPE, VENDOR_READ_REQUEST, 0x8383, 0, buffer, 1, 100);

            conn.controlTransfer(VENDOR_WRITE_REQUEST_TYPE, VENDOR_WRITE_REQUEST, 0, 1, null, 0, 100);
            conn.controlTransfer(VENDOR_WRITE_REQUEST_TYPE, VENDOR_WRITE_REQUEST, 1, 0, null, 0, 100);


            boolean typeHX = true; //MPL2303SA 超小型USBシリアル・モジュールは true (http://www.marutsu.co.jp/shohin_137791/ )
            long baud = 115200 ;
            //long baud = 9600 ; こっちでも動作を確認した
            int stop = 0 ;//0:1bit 1:1.5bit 2:2bit
            int parity = 0 ;//0:none 1:odd 2:even
            int dataBit = 8 ;

            if (typeHX ) {
                conn.controlTransfer(VENDOR_WRITE_REQUEST_TYPE, VENDOR_WRITE_REQUEST, 2, 0x44, null, 0, 100);
            }
            else {
                conn.controlTransfer(VENDOR_WRITE_REQUEST_TYPE, VENDOR_WRITE_REQUEST, 2, 0x24, null, 0, 100);
            }

            byte[] buf = new byte[7];

            //conn.controlTransfer(GET_LINE_REQUEST_TYPE, GET_LINE_REQUEST, 0, 0, buf, 7, 100);
            //conn.controlTransfer(VENDOR_WRITE_REQUEST_TYPE, VENDOR_WRITE_REQUEST, 0, 1, null, 0, 100);
            buf[0]=(byte) (baud & 0xff);
            buf[1]=(byte) ((baud >> 8) & 0xff);
            buf[2]=(byte) ((baud >> 16) & 0xff);
            buf[3]=(byte) ((baud >> 24) & 0xff);

            buf[4] = (byte)stop ;

            buf[5] = (byte)parity;  //

            buf[6] = (byte)dataBit ;

            conn.controlTransfer(SET_LINE_REQUEST_TYPE, SET_LINE_REQUEST, 0, 0, buf, 7, 100); //書き込み
            dbg("buf=" + buf[0] + "," + buf[1] + "," + buf[2] + "," + buf[3] + "," + buf[4] + "," + buf[5] + "," + buf[6]);

            conn.controlTransfer(VENDOR_WRITE_REQUEST_TYPE, VENDOR_WRITE_REQUEST, 0, 0, null, 0, 100);//flow none


			UsbEndpoint epIN = null;
			UsbEndpoint epOUT = null;

			UsbInterface usbIf = dev.getInterface(0);

            // endpoint addr 0x82 = output bulk
            epOUT = usbIf.getEndpoint(1); 
            if ((epOUT.getType() != UsbConstants.USB_ENDPOINT_XFER_BULK) || (epOUT.getDirection() != UsbConstants.USB_DIR_OUT)) {
                Log.e(MASYS.DEBUG_TAG, "epOUT error");
            }
		
            // endpoint addr 0x83 = input bulk
            epIN = usbIf.getEndpoint(2); 
            if ((epIN.getType() != UsbConstants.USB_ENDPOINT_XFER_BULK) || (epIN.getDirection() != UsbConstants.USB_DIR_IN)) {
                Log.e(MASYS.DEBUG_TAG, "epIN error");
            }

            dbg("-----------------");
			// android.os.Process.setThreadPriority(android.os.Process.THREAD_PRIORITY_URGENT_AUDIO);
			android.os.Process.setThreadPriority(android.os.Process.THREAD_PRIORITY_URGENT_DISPLAY);

			while( true ){// this is the main loop for transferring
				GetDataLoop(conn, epOUT, epIN);
				if( mStop ){
					mStopped = true;
					return;
				}
			}
		}
	};


	//USBデータ取得ループ。コマンドがある場合には、コマンドの送信を行う。
	private boolean GetDataLoop(UsbDeviceConnection conn, UsbEndpoint epOUT, UsbEndpoint epIN) {
		byte[] rawBuffer = new byte[64];
		byte[] dataBuffer = new byte[800];
		int dataBufPnt;
		int length;
		final int headerLength = 2;
		// 測定器停止命令
		dbg("StopMeasure before start ----------------");
		StopMeasure(conn, epOUT, epIN);
		//conn.controlTransfer(0x40, 0, 1, 0, null, 0, 0);// clear Rx
		dbg("StopMeasure before end ----------------");

		// 測定開始
		dbg("GetDataLoop----------------");
		String get = "start\n";
		byte[] getBytes = get.getBytes();
        SleepMs( 1000 ) ;
        dbg("start sended!!! len="+ getBytes.length) ;
		conn.bulkTransfer(epOUT, getBytes, getBytes.length, 500);
		dataBufPnt = 0;
        Log.d(MASYS.DEBUG_TAG, "start sended!!!" ) ;
		for(;;){
            //Log.d(MASYS.DEBUG_TAG, "mSenddataExist.get()="+mSenddataExist.get());
			if( mSenddataExist.get() != INVALID_SEND_DATA ){// 送信すべきものがある場合には、送信する
                Log.d(MASYS.DEBUG_TAG, "set reg");
				// ここで行うのは、受信の bulkTransfer と、送信の bulkTransfer を、別スレッドで行うと危なそうだから
				changeRegisterCmdToUsb(mSenddataExist.get(), mChangeRegisterValue, conn, epOUT);
				mSenddataExist.set( INVALID_SEND_DATA);
				//dbg("usb regset end");
			}

			length = conn.bulkTransfer(epIN, rawBuffer, 64, 0);
            if( length <= 0 ) {
                continue ;
            }
            dbg("recvlen="+length ) ;
            dumpByteStr(rawBuffer,length);

			for(int i = 0; i < length; i++){
				byte readByte = rawBuffer[i];
				//l("*"+Integer.toHexString(readByte));
				if( readByte < ' ' ){
					dataBuffer[dataBufPnt] = 0;
                    //dumpByteStr( dataBuffer, dataBufPnt ) ;
					if( dataBufPnt == (dataStrlenPerChannel * DataChannelMax) ){
						short data[] = transStrToShort(dataBuffer);
						for(int dn = 0; dn < DataChannelMax; dn++){
                            mNowData[ dn ] = data[ dn ] ;
                            Log.d(MASYS.DEBUG_TAG, "data["+dn+"]="+data[dn]);
						}
						// SleepMs(1);
					}else{
						//conn.controlTransfer(0x40, 0, 1, 0, null, 0, 0);// clear Rx あまり効果がない
						mdbgRawErrorDataCount++;
					}
					dataBufPnt = 0;
				}else{
					dataBuffer[dataBufPnt] = readByte;
					dataBufPnt++;
				}
			}
			// SleepMs(0); //下手に待つと、受信バッファがオーバーフローしてしまう。
			if( mStop ){
				StopMeasure(conn, epOUT, epIN);
				return true;
			}
		}
	}
    private void dumpByteStr( byte[] dataBuffer, int length ) {
        byte[] limitBuf = new byte[ length ] ;
        //copy( limitBuf,dataBuffer, length ) ;
        System.arraycopy( dataBuffer, 0, limitBuf, 0, length ) ;
        try {
            String debugStr = new String(limitBuf,"UTF-8") ;
            Log.d(MASYS.DEBUG_TAG,debugStr);
        } catch (UnsupportedEncodingException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

	
	//USBにコマンドを送る
	private void changeRegisterCmdToUsb(int registerNumber, int registerValue, UsbDeviceConnection conn, UsbEndpoint epOUT) {
		byte[] buffer = itoa3(registerValue, 2);
		buffer[0] = 'r';// セットコマンド
		buffer[1] = (byte) ('0' + registerNumber);// レジスタ番号
		buffer[6]= '\r';

		Log.d(MASYS.DEBUG_TAG, "changeRegisterCmdToUsb="+dbgByte(buffer, 5));

		conn.bulkTransfer(epOUT, buffer, 7, 500);

	}

	byte[] mUsbWriteBuffer = new byte[20];// オブジェクトの生成をしたくないので、ここに置く

	private byte[] itoa3(int value, int offset) {
		int num = 100;
		int i;
		//dbg("itoa3 value="+value);
        if( value < 0 ) {
            mUsbWriteBuffer[ offset ] = '-' ;
            value = -value ;
        }
        else {
            mUsbWriteBuffer[ offset ] = ' ' ;
        }
        offset ++ ;
		for(i = 0; i < 3; i++){
			mUsbWriteBuffer[i + offset] = (byte) ((value / num) + '0');
			value %= num;
			num /= 10 ;
			//dbgByte( mUsbWriteBuffer[i + offset] );
		}
		mUsbWriteBuffer[i+offset] = 0;
		return mUsbWriteBuffer;
	}
	private String dbgByte( byte a) {
		byte[] data = new byte[1];
		data[0] = a ;
		String b="";
        try{
	        b = new String( data, "UTF-8");
        }catch( UnsupportedEncodingException e ){
	        // TODO Auto-generated catch block
	        e.printStackTrace();
        }
		dbg( "byte->"+b);
		return b ;
	}
	private String dbgByte( byte[] a, int len) {
		int i ;
		byte[] data = new byte[len];
		for( i = 0 ; i < len ; i ++ ) {
			data[i]=a[i];
		}
		String b="";
        try{
	        b = new String( data, "UTF-8");
        }catch( UnsupportedEncodingException e ){
	        // TODO Auto-generated catch block
	        e.printStackTrace();
        }
		dbg( "byte->"+b);
		return b ;
	}

	//停止コマンドを送る。安全のため、2回行う。
	private void StopMeasure(UsbDeviceConnection conn, UsbEndpoint epOUT, UsbEndpoint epIN) {
		// dbg("stop");
		final int headerLength = 2;
		byte[] rawBuffer = new byte[128];
		//conn.controlTransfer(0x40, 0, 1, 0, null, 0, 0);// clear Rx
		for(int i = 0; i < 2; i++){// まずは、停止を確実に行う
			String get = "stop\n";
			byte[] getBytes = get.getBytes();
			dbg("stop send");
			conn.bulkTransfer(epOUT, getBytes, getBytes.length, 500);
			SleepMs(100);
		}
        if( false ) {
            for(;;){// stop のリプライを読み飛ばす
                SleepMs(200);
                int length = conn.bulkTransfer(epIN, rawBuffer, rawBuffer.length, 0);
                if( length <= 0 ){
                    // dbg("stop success");
                    return;
                }
                if( mStop ){
                    return;
                }
            }
        }
	}

	short[] mRawData = new short[DataChannelMax];// オブジェクトを動的に生成したくないので、ここに置く
	byte[] mTmpByte = new byte[dataStrlenPerChannel + 1];// オブジェクトを動的に生成したくないので、ここに置く

	private short[] transStrToShort(byte dataBuffer[]) {
		for(int i = 0; i < DataChannelMax; i++){
			int strPnt = i * dataStrlenPerChannel;
			mTmpByte[0] = dataBuffer[strPnt + 0];
			mTmpByte[1] = dataBuffer[strPnt + 1];
			mTmpByte[2] = dataBuffer[strPnt + 2];
			mTmpByte[3] = dataBuffer[strPnt + 3];
			mTmpByte[4] = 0;
			mRawData[i] = byteStringToShort(mTmpByte);
		}
		return mRawData;

	}

	private short byteStringToShort(byte dataBuffer[]) {
		int pointer = 0;
		boolean signFlag = false;
		if( dataBuffer[0] == '-' ){
			signFlag = true;
			pointer = 1;
		}
		double answer = 0;
		for(;;){
			answer *= 10;
			answer += dataBuffer[pointer] - '0';
			pointer++;
			if( dataBuffer[pointer] == 0 ){
				break;
			}
		}
		if( signFlag == true ){
			return (short) (0 - answer);
		}
		return (short) answer;
	}

	private static void dbg(Object s) {
		Log.d(MASYS.DEBUG_TAG, "[" + s.toString() + "]");
	}

	private static void e(Object s) {
		Log.e(MASYS.DEBUG_TAG, "[" + s.toString() + "]");
	}

	void SleepMs(int ms) {
		try{
			Thread.sleep(ms);
		}catch( InterruptedException e ){
			// TODO 自動生成された catch ブロック
			e.printStackTrace();
		}
	}

	//設定値の読み込み
	void loadDefaultPreference() {
		int res ;
		SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(this);

		res = pref.getInt(MASYS.SettingKind0Keyword, mVoltMenuSelect);
		mVoltMenuSelect = res;

		res = pref.getInt(MASYS.SettingKind1Keyword, mSecMenuSelect);
		mSecMenuSelect = res;
		dbg("loadDefaultPreference  mvolt=" + mVoltMenuSelect + " msec=" + mSecMenuSelect);

		res = pref.getInt(MASYS.D0SettingKeyword, mRegisterValue[0]);
		mRegisterValue[0] = res;

		res = pref.getInt(MASYS.D1SettingKeyword, mRegisterValue[1]);
		mRegisterValue[1] = res;

		res = pref.getInt(MASYS.D2SettingKeyword, mRegisterValue[2]);
		mRegisterValue[2] = res;

		res = pref.getInt(MASYS.D3SettingKeyword, mRegisterValue[3]);
		mRegisterValue[3] = res;

		res = pref.getInt(MASYS.D4SettingKeyword, mRegisterValue[4]);
		mRegisterValue[4] = res;

	}

	//設定値の保存
	void savePreference() {
		SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(this);
		SharedPreferences.Editor editor;
		editor = pref.edit();

		editor.putInt(MASYS.SettingKind0Keyword, mVoltMenuSelect);
		editor.putInt(MASYS.SettingKind1Keyword, mSecMenuSelect);

		editor.putInt(MASYS.D0SettingKeyword, mRegisterValue[0]);
		editor.putInt(MASYS.D1SettingKeyword, mRegisterValue[1]);
		editor.putInt(MASYS.D2SettingKeyword, mRegisterValue[2]);
		editor.putInt(MASYS.D3SettingKeyword, mRegisterValue[3]);
		editor.putInt(MASYS.D4SettingKeyword, mRegisterValue[4]);

		editor.commit();
		dbg("savepref  mvolt=" + mVoltMenuSelect + " msec=" + mSecMenuSelect);
	}


	//設定画面から帰ってきたときの処理
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent intent) {
		super.onActivityResult(requestCode, resultCode, intent);
		if( requestCode == REQUEST_PREFERENCE ){
			if( resultCode == RESULT_OK ){
				Bundle extras = intent.getExtras();
				if( extras != null ){
					mVoltMenuSelect = extras.getInt(MASYS.SettingKind0Keyword);
					mSecMenuSelect = extras.getInt(MASYS.SettingKind1Keyword);
					dbg("pref->volt=" + mVoltMenuSelect + " sec=" + mSecMenuSelect + "");

					savePreference();
				}
			}
		}
	}

	//戻るボタンでの処理
	@Override
	public boolean dispatchKeyEvent(KeyEvent event) {
		Log.d(MASYS.DEBUG_TAG, "dispatchKey");
		if( event.getAction() == KeyEvent.ACTION_DOWN ){
			switch( event.getKeyCode() ){
			case KeyEvent.KEYCODE_BACK:
				new AlertDialog.Builder(this).setTitle("Exit ?").setMessage("Exit ?").setPositiveButton("Yes", new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int whichButton) {
						finish();
					}
				}).setNegativeButton("No", new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int whichButton) {
					}
				}).show();
				return true;
			case KeyEvent.KEYCODE_HOME:// androidでは、HOME のイベントは取得できないことになっている
				Log.d(MASYS.DEBUG_TAG, "HOME down");
				return true;
			default:
				break;
			}
		}else if( event.getAction() == KeyEvent.ACTION_UP ){
			switch( event.getKeyCode() ){
			case KeyEvent.KEYCODE_BACK:
				return true;
			default:
				break;
			}
		}
		// 自動生成されたメソッド・スタブ
		return super.dispatchKeyEvent(event);
	}

	// ---------------------------------------------------------------------------------------
	// Menu Button
	// ---------------------------------------------------------------------------------------
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		menu.add(Menu.NONE, MENU_ID_SETTING, Menu.NONE, "Setting ...");
		menu.add(Menu.NONE, MENU_ID_CLEARTEXT, Menu.NONE, "Other ...");
		/*
		 * if(mSerial!=null) { if(mSerial.isConnected()) { menu.getItem(MENU_ID_OPENDEVICE).setEnabled(false); } else { menu.getItem(MENU_ID_CLOSEDEVICE).setEnabled(false); } }
		 */return super.onCreateOptionsMenu(menu);
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch( item.getItemId() ){
		case MENU_ID_SETTING:
			Intent i = new Intent().setClassName(this.getPackageName(), PrefActivity.class.getName());
			i.putExtra(MASYS.SettingKind1Keyword, mSecMenuSelect);
			i.putExtra(MASYS.SettingKind0Keyword, mVoltMenuSelect);//
			dbg("volt=" + mVoltMenuSelect + " sec=" + mSecMenuSelect + "->pref "+this.getPackageName()+"->"+PrefActivity.class.getName());
			//startActivityForResult(new Intent().setClassName(this.getPackageName(), PrefActivity.class.getName()), REQUEST_PREFERENCE);
			startActivityForResult(i, REQUEST_PREFERENCE);

			return true;
		case MENU_ID_CLEARTEXT:
			return true;
		default:
			return false;
		}
	}

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);

		mSurfaceView = new MySurfaceView(this);
		setContentView(mSurfaceView);
		registerForContextMenu(mSurfaceView);// コンテクストメニュー

		for(int i = 0; i < MASYS.VOLUME_MAX; i++){
			mRegisterValue[i] = 25; // 適当な値にしておく
		}
		loadDefaultPreference();
		
		dbg("--onCreate");
		mIsDrawEffective = true;

		mSenddataExist.set(INVALID_SEND_DATA );

	}

	@Override
	protected void onStart() {
		mStop = false;
		if( isFirstEnumerate ){
			isFirstEnumerate = false;
			enumerate();
		}
		super.onStart();
		dbg("--onStart");
		mIsDrawEffective = true;
	}

	@Override
	public void onRestart() {
		super.onRestart();
		mIsDrawEffective = true;
	}

	@Override
	public void onResume() {
		super.onResume();
		mIsDrawEffective = true;
	}

	@Override
	public void onPause() {
		super.onPause();
		mIsDrawEffective = false;
	}

	@Override
	protected void onStop() {
		dbg("--- onStop--");
		// mStop = true;
		// unregisterReceiver(mPermissionReceiver);
		super.onStop();
		mIsDrawEffective = false;
	}

	@Override
	protected void onDestroy() {
		// sActivityContext = null;
		mStop = true;
		unregisterReceiver(mPermissionReceiver);
		super.onDestroy();
		mIsDrawEffective = false;
		dbg("onDestroy");
	}
}
