package com.ca.testapp;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.TextView;

public class PrefActivity extends Activity {
	int mMilliSecSelect ;

	
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.preference);

		//まず、インテントで、選択状態を受け取る
		Intent intent = getIntent();
		mMilliSecSelect  = getSelectNo(intent,MASYS.SettingKind1Keyword);
		dbg("mMilliSecSelect="+mMilliSecSelect);
		
        //時間
		Spinner timeSpinner= makeSpinnerAndSetSelection(MASYS.GraphSecDivMenu, R.id.spinner2, mMilliSecSelect);
        timeSpinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view,int position, long id) {
                Spinner spinner = (Spinner) parent;
                mMilliSecSelect = spinner.getSelectedItemPosition();
            }
            @Override
            public void onNothingSelected(AdapterView<?> arg0) {
            }
        });
		
        
        //終了ボタン
        Button button = (Button) findViewById(R.id.button1);
		button.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				//インテントで選択状態を渡す。
				Intent intent = new Intent();
				setSelectNo(intent, MASYS.SettingKind1Keyword, mMilliSecSelect);
				setResult(RESULT_OK, intent);
				finish();
			}
		});
	}
	private Spinner makeSpinnerAndSetSelection( String[] menuItemStr, int spinnerId, int selectNo) {
		ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item);
		adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		for( int i = 0 ; i < menuItemStr.length ; i ++ ) {
			adapter.add(menuItemStr[i]) ;
		}
		Spinner spinner = (Spinner)findViewById(spinnerId);
		spinner.setAdapter(adapter);
		spinner.setSelection(selectNo);
		return spinner ;
	}
	private int getSelectNo( Intent intent, String keyName) {
		//return Integer.parseInt(intent.getStringExtra(keyName));
		return intent.getIntExtra(keyName, 0) ;
		
	}
	private void setSelectNo(Intent intent, String keyName, int selectNo) {
		intent.putExtra(keyName, (int)selectNo ) ;
	}
	private static void dbg(Object s) {
		Log.d(MASYS.DEBUG_TAG, "[" + s.toString() + "]");
	}
}
